#!/bin/sh
# ============================================================================
#
# This file is part of the 'Tweaks' package
# 
# This program is free software; you can redistribute it and/or modify it 
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# Author: Mijzelf <Mijzelf@live.com>
#
# ============================================================================
PKG_NAME="Tweaks"
THIS_SCRIPT="Tweaks"
PKG_FIRMWARE=4

############################################################
## Check if we are in upgradig mode. From the point of view of the package
## an upgrade is a uninstall followed by a install. So if you want to preserve
## something over an upgrade, you have to detect it somehow
##
## Function sets PKG_UPGRADE > 0 when upgrading, 
## and PKG_UPGRADE=0 when not
############################################################
IsUpgrading()
{
	PKG_UPGRADING=0
	local dir=
	for dir in "/usr/local/zy-pkgs/" "/i-data/.system/zy-pkgs/"
	do
		local logfile=${dir}tmp/zypkg.log
		[ ! -f ${logfile} ] && continue

		local lastupdate=` grep "Upgrade Mode" ${logfile} | tail -n 1 | grep "\[${PKG_NAME}\]" | awk -v OFS=' ' '{print $1, $2}' `

	        [ "${lastupdate}" = "" ] && return 1

		local since1970=` TZ=GMT date -d "${lastupdate}" +%s `
		local now=`date +%s `
		local ago=""
		let ago=now-since1970
		[ $ago -eq 0 ] && ago=1
		[ 300 -gt $ago ] && PKG_UPGRADING=$ago && return 0

		return 1
	done

	# We shouldn't be here
	return 1
}

#############################################################
## Dummy logcode
#############################################################
Log() 
{
	return
}

######################################
## Find the IP address of the box
FrameworkGetIPAddress()
{
	# Detect interfaces
	local interfaces=` ifconfig | grep -e "^egiga" -e "^bond" -e "^eth" | cut -d ' ' -f 1 `

	# And find the IP (v4) address
	for interface in $interfaces
	do
		local address=` ifconfig ${interface} | grep "inet addr" | tr -s ' ' `
		if [ "${address}" != "" ] ; then
			echo ${address} | cut -d ' ' -f 2 | cut -d ':' -f 2
			return
		fi
	done
	hostname # What else?
}

#####################################
## Echo the URL of the package
FrameworkGetLink()
{
	# Do we have a webinterface at all?
	[ ! -d ${PKG_ROOT}/gui/${PKG_NAME}/ ] && exit 0

	local address=` FrameworkGetIPAddress `

	# Seach for configured ports
	local ports=
	for directory in /etc/pkg_service_conf /etc/service_conf
	do
		[ ! -d ${directory} ] && continue

		ports=` grep "^Listen" ${directory}/httpd_zld*.conf | awk '{ print $2 }' `
		ports="$ports ` grep "^<VirtualHost" ${directory}/httpd_zld*.conf | cut -d ':' -f 2 | cut -d '>' -f 1 `"
		ports=` echo $ports | tr -s ' ' | tr ' ' '\n' | sort | uniq | grep -v 8082 `
		break
	done

	for port in $ports
	do
		# Find out if it's https:
		protocol=http
		defaultport=80
		grep -i "^<VirtualHost.*${port}" -A 50 ${directory}/httpd_zld*.conf >/tmp/.$$.${PKG_NAME}

		while read line
		do
			if echo $line | grep -i "^</VirtualHost" >/dev/null
			then
				break
			fi

			if echo $line | grep -i "SSLEngine *On" >/dev/null
			then
				protocol=https
				defaultport=443
			fi
		done </tmp/.$$.${PKG_NAME}
		rm /tmp/.$$.${PKG_NAME}

		[ ${defaultport} -eq 443 ] && continue # Package manager crashes on https :$


		[ $port -eq $defaultport ] && port="" || port=":${port}"

		local url="${protocol}://${address}${port}/pkg/${PKG_NAME}/"

		echo  $url
		# We can only output a single url
		return
	done
}

######################################
## Status get and set
FrameworkStatus()
{
	local pkg_config_file="${PKG_ROOT}/config/${PKG_NAME}/config"
	if [ "get" = "$1" ] ; then
		if [ ! -f ${pkg_config_file} ] ; then
			FrameworkStatus set Disabled
		fi
		cat ${pkg_config_file}
		return
	elif [ "set" = "$1" ] ; then
		mkdir -p ` dirname ${pkg_config_file} `
		
		echo $2 >${pkg_config_file}
	fi
}

################################################
## Run or stop the package
FrameworkRun()
{
	if [ $1 -eq 1 ] ; then
		# Startup
		STATUS=` FrameworkStatus get `
		[ "$STATUS" != "Enabled" ] && return	# We're not enabled

		# Do we have a webinterface?
		if [ -d ${PKG_ROOT}/gui/${PKG_NAME}/ ] ; then
			# Aparently 
			for httpdconf in /etc/pkg_service_conf/httpd_package2.conf
			do
				[ ! -f ${httpdconf} ] && continue
				
				local service_conf=` dirname $httpdconf `

				echo Alias /pkg/${PKG_NAME}/ ${PKG_ROOT}/gui/${PKG_NAME}/ >${service_conf}/${PKG_NAME}.conf
				if ! grep ${PKG_NAME}.conf ${httpdconf} >/dev/null
				then
					sed -i "1iInclude ${service_conf}/${PKG_NAME}.conf" ${httpdconf}
				fi

				# Let the package manager restart the server
				touch /tmp/restart_httpd
				break
			done

		fi

		[ ! -f /lib/ld-linux.so.3 -a -f /lib/ld-linux-armhf.so.3 ] && ln -s ld-linux-armhf.so.3 /lib/ld-linux.so.3 

		Startup
		return
	fi

	Shutdown
	
	for httpdconf in /etc/pkg_service_conf/httpd_package2.conf
	do
		[ ! -f ${httpdconf} ] && continue
		grep -v ${PKG_NAME}.conf ${httpdconf} >/tmp/$$.httpd.conf
		mv /tmp/$$.httpd.conf ${httpdconf}
		touch /tmp/restart_httpd
	break
	done

}

FrameworkVersion()
{
	local controlfile=${PKG_ROOT}/zypkg_conf/info/${PKG_NAME}.control
	local version=$( grep "^Version:" ${controlfile} | awk -F"zypkg" '{print $2}' )
	exit $version
}

FrameworkParseParams()
{
	case $1 in
		getlink)
			FrameworkGetLink
			;;
		status)
			FrameworkStatus get
			;;
		enable)
			FrameworkStatus set Enabled 
			FrameworkRun 1 </dev/null
			;;
		disable)
			FrameworkRun 0 </dev/null
			FrameworkStatus set Disabled 
			;;
		startup)
			FrameworkRun 1 </dev/null
			;;
		shutdown)
			FrameworkRun 0 </dev/null
			;;
		version)
			FrameworkVersion
			;;
	esac
}

Log

PKG_ROOT="/usr/local/zy-pkgs"
PKG_MEDION=0

TWEAKS_PIPE=/var/run/${PKG_NAME}.pipe
TWEAKS_PID=/var/run/${PKG_NAME}.pid
TWEAKS_STORAGE=/tmp/.${PKG_NAME}/
TWEAKS_PKG_ROOT=${PKG_ROOT}

Log()
{
	[ -f /tmp/${PKG_NAME}.log ] && echo "$@" >>/tmp/${PKG_NAME}.log
}

ReadParam()
{
	local value="` grep ^${1} ${TWEAKS_CONFFILE} `"
	[ -z "$value" ] && echo "" && return 0
	value="` echo $value | cut -d '=' -f 2 `"
	value="` echo $value `"
	[ -z $value ] && echo "" && return 0
	echo $value
}

CreateEnvironment()
{
	local env=${TWEAKS_STORAGE}env

	echo TWEAKS_PKG_ROOT=${TWEAKS_PKG_ROOT} >${env}
	if [ ${PKG_FIRMWARE} -eq 5 ] && [ -f /firmware/mnt/info/revision ] && [ $( cat /firmware/mnt/info/revision ) -ge 50567 ] ; then
		echo TWEAKS_FIRMWARE=${PKG_FIRMWARE}20 >>${env}
	else
    		echo TWEAKS_FIRMWARE=${PKG_FIRMWARE}00 >>${env}
	fi

	TWEAKS_PKG_DIR=/i-data/md0/.system
	[ ${PKG_FIRMWARE} -gt 4 ] && TWEAKS_PKG_DIR=/i-data/sysvol/.PKG
	echo TWEAKS_PKG_DIR=${TWEAKS_PKG_DIR} >>${env}
	
	TWEAKS_PLUGINDIR=${PKG_ROOT}/gui/${PKG_NAME}/plugins/
	
	if [ ! -d ${TWEAKS_PLUGINDIR} ] ; then
		TWEAKS_PLUGINDIR=${TWEAKS_PKG_ROOT}/pkggui/${PKG_NAME}/plugins/
	fi
	
	echo TWEAKS_PLUGINDIR=${TWEAKS_PLUGINDIR} >>${env}
	
	TWEAKS_CONFDIR=${PKG_ROOT}/etc/
	echo TWEAKS_CONFDIR=${TWEAKS_CONFDIR} >>${env}
	
	TWEAKS_CONFFILE=${TWEAKS_CONFDIR}${PKG_NAME}.conf
	echo TWEAKS_CONFFILE=${TWEAKS_CONFFILE} >>${env}

	[ -f /firmware/mnt/info/modelid ] && TWEAKS_MODEL=$( cat /firmware/mnt/info/modelid )
	[ -f /zyxel/mnt/info/modelid ] && TWEAKS_MODEL=$( cat /zyxel/mnt/info/modelid )
	echo TWEAKS_MODEL=${TWEAKS_MODEL} >>${env}

	TWEAKS_MEDION=${PKG_MEDION}
	echo TWEAKS_MEDION=${TWEAKS_MEDION} >>${env}
	
	chmod 644 ${env}
}

DeamonCleanup()
{
    [ -e ${TWEAKS_PIPE} ] && rm ${TWEAKS_PIPE} 
    [ -f ${TWEAKS_PID} ] && rm ${TWEAKS_PID}
}

Daemon()
{
	mkdir -p ${TWEAKS_STORAGE}
	echo $$ >${TWEAKS_PID}
	mknod ${TWEAKS_PIPE} p
		
	trap DeamonCleanup EXIT
	
	chmod a+w ${TWEAKS_PIPE}
	Log Daemon starting

	if ! grep ${TWEAKS_STORAGE}shutdown_pending /etc/init.d/rc.shutdown >/dev/null
	then
		sed -i "2 i\
touch ${TWEAKS_STORAGE}shutdown_pending" /etc/init.d/rc.shutdown 
	fi

	CreateEnvironment
	
	touch ${TWEAKS_CONFFILE}
	chown root:nobody ${TWEAKS_CONFFILE}
	chmod 660 ${TWEAKS_CONFFILE}

	Log "Deamon     load plugins"
	local plugins=""
	for file in ${TWEAKS_PLUGINDIR}*.sh
	do
		Log "Daemon         ${file}"
		. $file
		plugins="${plugins} ${PLUGIN}"
		Log "Daemon             => ${PLUGIN}"
	done
	Log "Daemon     plugins loaded"
	
	Log "Daemon     start plugins"
	for PLUGIN in ${plugins}
	do
		Log "Daemon         ${PLUGIN}_OnStart"
		${PLUGIN}_OnStart
	done
	Log "Daemon     plugins started"
	
	Log Daemon started

	while true
	do
		exec <${TWEAKS_PIPE}
		read line
		exec </dev/zero
		
		Log Daemon catch $line
		local cmd=` echo $line | cut -d ' ' -f 1 `
		local args=` echo $line | cut -d ' ' -f 2- `
		
		[ "$cmd" = "quit" ] && break
		
		for PLUGIN in $plugins
		do
			if [ "$cmd" = "$PLUGIN" ] 
			then
				Log Daemon ${PLUGIN}_OnCommand $args
				${PLUGIN}_OnCommand $args
				break
			fi
		done
	done

	TRAP "Log Daemon stopped 2" EXIT
	rm ${TWEAKS_PIPE}
	
	[ -f ${TWEAKS_STORAGE}shutdown_pending ] && SHUTDOWN_PENDING=1
	
	for PLUGIN in $plugins
	do
		Log Daemon ${PLUGIN}_OnStop
		${PLUGIN}_OnStop
	done
	Log Daemon stopped
	rm ${TWEAKS_PID}
	exit 0
}

Command()
{
	if [ -p ${TWEAKS_PIPE} ] ; then
		Log Send command $@
		echo $@ >${TWEAKS_PIPE}
		return 0
	fi
	Log No ${TWEAKS_PIPE}
	return 1
}

Startup()
{
	Command quit
	if [ $? -eq 0 ] ; then
		while [ -p ${TWEAKS_PIPE} ] 
		do
		    sleep 1
		done
		sleep 1
	fi

	# For NAS500	
	[ ! -f /lib/ld-linux.so.3 -a -f /lib/ld-linux-armhf.so.3 ] && ln -s ld-linux-armhf.so.3 /lib/ld-linux.so.3 

	$0 daemon $$ >/dev/null 2>&1 &
}

Shutdown()
{
	Command quit
	for wait in 1 2 3 4 5 6 7 8 9 
	do
	    [ ! -f ${TWEAKS_PID} ] && return 0
	    sleep 1
	done
	# Stale pid file?
}

Log $0 $@

case $1 in
	command)
		shift 
		Command "$@"
		exit $?
		;;
	daemon)
		Daemon
		;;
esac

FrameworkParseParams "$@"

exit 0
